#include <stdio.h>
#ifdef HAVE_ERRNO_H
# include <errno.h>
#endif
#ifdef HAVE_STRING_H
# include <string.h>
#endif
#include <sys/utsname.h>

#ifndef HAVE_STRCHR
# define strchr index
# define strrchr rindex
#endif

static int usage()
{
  fprintf(stderr, "usage: uname [-snrvma]\n");
  exit(2);
}

int main(argc, argv)
int argc;
char **argv;
{
  int o;
  struct utsname ut;
  char const *name=strrchr(argv[0], '/');
  if(name)
    name++;
  else
    name=argv[0];
  if(!strcmp(name, "arch") || !strcmp(name, "mach"))
    o=16;
  else if(argc > 1) {
    o=0;
    for(; *++argv; ) {
      char *p=*argv;
      if(*p++!='-' || !*p) usage();
      for(; *p; p++)
	switch(*p) {
	  case 's': o|= 1; break;
	  case 'n': o|= 2; break;
	  case 'r': o|= 4; break;
	  case 'v': o|= 8; break;
	  case 'm': o|=16; break;
	  case 'a': o =31; break;
	  default: usage();
	}
    }
  } else
    o=1;
  if(uname(&ut)) {
    perror("uname");
    exit(1);
  }
  if(o& 1) printf("%s%c", ut.sysname,  o&30 ? ' ' : '\n');
  if(o& 2) printf("%s%c", ut.nodename, o&28 ? ' ' : '\n');
  if(o& 4) printf("%s%c", ut.release,  o&24 ? ' ' : '\n');
  if(o& 8) printf("%s%c", ut.version,  o&16 ? ' ' : '\n');
  if(o&16) printf("%s%c", ut.machine,               '\n');
  exit(0);
}
